# Summary

- [xlsx](README.md#sheetjs-js-xlsx)
- [Getting Started](README.md#getting-started)
  * [Installation](README.md#installation)
  * [Usage](README.md#usage)
  * [The Zen of SheetJS](README.md#the-zen-of-sheetjs)
  * [JS Ecosystem Demos](README.md#js-ecosystem-demos)
- [Acquiring and Extracting Data](README.md#acquiring-and-extracting-data)
  * [Parsing Workbooks](README.md#parsing-workbooks)
  * [Processing JSON and JS Data](README.md#processing-json-and-js-data)
  * [Processing HTML Tables](README.md#processing-html-tables)
- [Processing Data](README.md#processing-data)
  * [Modifying Workbook Structure](README.md#modifying-workbook-structure)
  * [Modifying Cell Values](README.md#modifying-cell-values)
  * [Modifying Other Worksheet / Workbook / Cell Properties](README.md#modifying-other-worksheet--workbook--cell-properties)
- [Packaging and Releasing Data](README.md#packaging-and-releasing-data)
  * [Writing Workbooks](README.md#writing-workbooks)
  * [Writing Examples](README.md#writing-examples)
  * [Streaming Write](README.md#streaming-write)
  * [Generating JSON and JS Data](README.md#generating-json-and-js-data)
  * [Generating HTML Tables](README.md#generating-html-tables)
  * [Generating Single-Worksheet Snapshots](README.md#generating-single-worksheet-snapshots)
- [Interface](README.md#interface)
  * [Parsing functions](README.md#parsing-functions)
  * [Writing functions](README.md#writing-functions)
  * [Utilities](README.md#utilities)
- [Common Spreadsheet Format](README.md#common-spreadsheet-format)
  * [General Structures](README.md#general-structures)
  * [Cell Object](README.md#cell-object)
    + [Data Types](README.md#data-types)
    + [Dates](README.md#dates)
  * [Sheet Objects](README.md#sheet-objects)
    + [Worksheet Object](README.md#worksheet-object)
    + [Chartsheet Object](README.md#chartsheet-object)
    + [Macrosheet Object](README.md#macrosheet-object)
    + [Dialogsheet Object](README.md#dialogsheet-object)
  * [Workbook Object](README.md#workbook-object)
    + [Workbook File Properties](README.md#workbook-file-properties)
  * [Workbook-Level Attributes](README.md#workbook-level-attributes)
    + [Defined Names](README.md#defined-names)
    + [Workbook Views](README.md#workbook-views)
    + [Miscellaneous Workbook Properties](README.md#miscellaneous-workbook-properties)
  * [Document Features](README.md#document-features)
    + [Formulae](README.md#formulae)
    + [Row and Column Properties](README.md#row-and-column-properties)
    + [Number Formats](README.md#number-formats)
    + [Hyperlinks](README.md#hyperlinks)
    + [Cell Comments](README.md#cell-comments)
    + [Sheet Visibility](README.md#sheet-visibility)
    + [VBA and Macros](README.md#vba-and-macros)
- [Parsing Options](README.md#parsing-options)
  * [Input Type](README.md#input-type)
  * [Guessing File Type](README.md#guessing-file-type)
- [Writing Options](README.md#writing-options)
  * [Supported Output Formats](README.md#supported-output-formats)
  * [Output Type](README.md#output-type)
- [Utility Functions](README.md#utility-functions)
  * [Array of Arrays Input](README.md#array-of-arrays-input)
  * [Array of Objects Input](README.md#array-of-objects-input)
  * [HTML Table Input](README.md#html-table-input)
  * [Formulae Output](README.md#formulae-output)
  * [Delimiter-Separated Output](README.md#delimiter-separated-output)
    + [UTF-16 Unicode Text](README.md#utf-16-unicode-text)
  * [HTML Output](README.md#html-output)
  * [JSON](README.md#json)
- [File Formats](README.md#file-formats)
- [Testing](README.md#testing)
  * [Node](README.md#node)
  * [Browser](README.md#browser)
  * [Tested Environments](README.md#tested-environments)
  * [Test Files](README.md#test-files)
- [Contributing](README.md#contributing)
  * [OSX/Linux](README.md#osxlinux)
  * [Windows](README.md#windows)
  * [Tests](README.md#tests)
- [License](README.md#license)
- [References](README.md#references)